module Eric_Erb

    def self.paint_by_layer
        mod = Sketchup.active_model
        su_materials = mod.materials
        
        begin
            mod.start_operation("Paint By Layer", true)
        rescue ArgumentError
            mod.start_operation("Paint By Layer")
        end

        # Loop through entities & apply material based on layer name
        Sketchup.active_model.entities.each do |e|
            mat = su_materials[e.layer.name]
            unless mat.nil?
	            if e.is_a? Sketchup::Drawingelement then
	                e.material = mat
					e.back_material = mat if e.respond_to?('back_material=')
            	end
            end
        end

        mod.commit_operation
    end

end

unless file_loaded? File::basename(__FILE__)
    UI.menu('Plugins').add_item('Paint by Layer') { Eric_Erb.paint_by_layer }
    file_loaded File::basename(__FILE__)
end
